package com.example.beijing_daxing;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.example.beijing_daxing.adapter.InAdapter;
import com.example.beijing_daxing.base.AdapterClickCall;
import com.example.beijing_daxing.base.BaseActivity;
import com.example.beijing_daxing.base.MyRecultCall;
import com.example.beijing_daxing.base.MyResult;
import com.example.beijing_daxing.been.InStoreSelectBody;
import com.example.beijing_daxing.databinding.ActivityInBinding;
import com.example.beijing_daxing.uitls.SharedPreferencesUtils;
import com.example.beijing_daxing.vm.InStoreVM;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import okhttp3.RequestBody;

public class InActivity extends BaseActivity implements AdapterClickCall {
    private InStoreVM vm;
    private InAdapter adapter;
    private List<String> epcList;
    private ActivityInBinding binding;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_in);
        vm = new InStoreVM();
        binding.setVm(vm);
        initRequest();
        adapter = new InAdapter(this);
        epcList = new ArrayList<>();
        adapter.setList(epcList);
        adapter.setAdapterClickCall(this);
        binding.setAdapter(adapter);
    }

    @Override
    protected void sanRfid(List<String> epcs) {
        // Log.e("TAG", "sanRfid:" + epcs);

        epcs.stream().forEach(t -> {
            if (!epcList.contains(t)) {
                epcList.add(t);
            }
        });
        vm.setSanLength(epcList.size());
        adapter.notifyDataSetChanged();

    }

    private void initRequest() {
        OkGo.<MyResult>post(url + "/instore/select").tag(this).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                // Log.e("TAG", "onSuccess:" + );response.body()
                InStoreSelectBody inStoreSelectBody = gson.fromJson(response.body().getData().toString(), InStoreSelectBody.class);
                vm.initSelect(inStoreSelectBody.getBaseLocationList(), inStoreSelectBody.getBaseManufacturerList());
            }
        });
    }

    @Override
    public void clickItem(int index) {
        epcList.remove(index);
        adapter.notifyDataSetChanged();
        vm.setSanLength(epcList.size());
    }

    public void in_submit(View view) {
        String binchCode = vm.getBinchCode();
        if (binchCode == null || epcList.isEmpty()) return;
        vm.setEpcList(epcList);
        vm.setSubmitUser(SharedPreferencesUtils.getstring("user","test"));
        OkGo.<MyResult>post(url + "/instore/submit")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(vm)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        if (response.body().getCode()==0){
                            Toast.makeText(InActivity.this, "提交成功", Toast.LENGTH_SHORT).show();
                            finish();
                        }else {
                            Toast.makeText(InActivity.this, response.body().getMsg(), Toast.LENGTH_SHORT).show();
                        }
                    }
                });
    }
}