package com.example.beijing_daxing;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.Bindable;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableBoolean;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.example.beijing_daxing.adapter.StoreCheckAdapter;
import com.example.beijing_daxing.base.BaseActivity;
import com.example.beijing_daxing.base.MyRecultCall;
import com.example.beijing_daxing.base.MyResult;
import com.example.beijing_daxing.been.InStoreSelectBody;
import com.example.beijing_daxing.been.Stock;
import com.example.beijing_daxing.databinding.ActivityStoreCheckBinding;
import com.example.beijing_daxing.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import okhttp3.RequestBody;

public class StoreCheckActivity extends BaseActivity {


    private ObservableBoolean checkState;
    private List<Stock> list;
    private StoreCheckAdapter checkAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityStoreCheckBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_store_check);
        checkState = new ObservableBoolean();
        binding.setCheckState(checkState);
        checkAdapter = new StoreCheckAdapter(this);
        binding.setAdapter(checkAdapter);
        initRequest();
    }
    private List<String> tagList;
    @Override
    protected void sanRfid(List<String> epcs) {
        epcs.forEach(t -> {
           if (tagList.contains(t)){
               tagList.add(t);
               return;
           }
            var stock = new Stock();
            stock.setEpcCode(t);
            var index = list.indexOf(stock);
            if (index != -1) {
                list.get(index).setState("Y");
            }
        });
        checkAdapter.notifyDataSetChanged();
    }

    private void initRequest() {
        OkGo.<MyResult>post(url + "/storecheck/select").tag(this).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                if (body.getCode() == 0) {
                    list = gson.fromJson(body.getData().toString(), new TypeToken<List<Stock>>() {
                    }.getType());
                    tagList=new ArrayList<>();
                    checkAdapter.setList(list);
                    checkAdapter.notifyDataSetChanged();
                } else {
                    Toast.makeText(StoreCheckActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                }
            }
        });
    }

    public void check_read(View view) {
        var b = checkState.get();
        if (b) {
            handler.removeCallbacks(runnable);
        } else {
            handler.postDelayed(runnable, 0);
        }
        checkState.set(!b);
    }

    public void store_check_submit(View view) {
        handler.removeCallbacks(runnable);
        OkGo.<MyResult>post(url+"/storecheck/submit")
                .tag(this)
                .params("user", SharedPreferencesUtils.getstring("user","test"))
                .params("json",gson.toJson(list))
                // .upRequestBody(RequestBody.create(JSON, gson.toJson(list)))
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==0){
                            finish();
                            Toast.makeText(StoreCheckActivity.this, "提交成功", Toast.LENGTH_SHORT).show();
                        }else {
                            Toast.makeText(StoreCheckActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                        }
                    }
                });
    }

    @SuppressLint("HandlerLeak")
    private Handler handler = new Handler() {
        @Override
        public void handleMessage(@NonNull Message msg) {
            super.handleMessage(msg);
        }
    };
    private Runnable runnable = new Runnable() {
        @Override
        public void run() {
            sendBroadcast(broadcastIntent);
            handler.postDelayed(runnable, 1000);
        }
    };

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler=null;
        runnable=null;
    }
}