package com.example.beijing_daxing.base;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.Window;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.beijing_daxing.R;
import com.google.gson.Gson;
import com.handheld.UHFLonger.UHFLongerManager;

import java.util.List;

import okhttp3.MediaType;

public abstract class BaseActivity extends AppCompatActivity {
    public static String url = "http://192.168.0.102:90/api";
    // public static String url = "http://172.20.10.2:90/api";
    public ProgressDialog dialog;
    public Gson gson;
    public MediaType JSON = MediaType.parse("application/json; charset=utf-8");
    public UHFLongerManager uhfLongerManager;
    private MediaPlayer mediaPlayer;
    private   MyReceiver myReceiver;

    public   Intent broadcastIntent;

    @SuppressLint("UnspecifiedRegisterReceiverFlag")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        gson = new Gson();
        initDialog();
        initSan();
        Intent intent = new Intent();
        broadcastIntent = new Intent("android.rfid.FUN_KEY");
        broadcastIntent.putExtra("keydown", false);
    }

    public class MyReceiver extends BroadcastReceiver {

        @Override
        public void onReceive(Context context, Intent intent) {
            if (!intent.getBooleanExtra("keydown", false)) {
                List<String> strings = uhfLongerManager.inventoryRealTime();
                if (strings == null || strings.isEmpty()) {
                    return;
                }
                mediaPlayer.start();
                sanRfid(strings);
            }
        }
    }

    private void initDialog() {
        dialog = new ProgressDialog(this);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setCanceledOnTouchOutside(false);
        dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        dialog.setMessage("请求网络...");
    }
    private void initSan(){
        uhfLongerManager = MyApplication.getUhfLongerManager();
        // intentFilter.addAction("android.intent.action.FUN_KEY");
        myReceiver = new MyReceiver();
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("android.rfid.FUN_KEY");
        registerReceiver(myReceiver, intentFilter);
        mediaPlayer = MediaPlayer.create(this, R.raw.msg);
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(myReceiver);
    }

    protected abstract void sanRfid(List<String> epcs);
}